#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include <linux/i2c.h>


int
main(int argc, char *argv[])
{
    int  c,f;
    unsigned char buf[40];
    char *device = "/dev/i2c-0";
    int addr = 0xc0;
    float freq = 210.25; /* E10 - ARD */
    int ifreq,rc;
    
    /* parse options */
    while (-1 != (c=getopt(argc,argv,"hd:a:f:"))) {
	switch (c){
	case 'd':
	    device = optarg;
	    break;
	case 'a':
	    addr = strtol(optarg,NULL,0);
	    break;
	case 'f':
	    freq = atof(optarg);;
	    break;
	case 'h':
	default:
	    printf("poll IR chip\n");
	    printf("usage: %s [ -d device ]\n",argv[0]);
	    exit(1);
	}
    }

    fprintf(stderr,"%s / 0x%02x / %.2f MHz ...  ",device,addr,freq);
    ifreq = (freq + 38.9) * 16;
    buf[0] = (ifreq >> 8) & 0x7f;
    buf[1] = ifreq        & 0xff;
    buf[2] = 0x8e;
    buf[3] = 0x90;

    if (-1 == (f = open(device,O_RDWR))) {
	fprintf(stderr,"open %s: %s\n",device,strerror(errno));
	exit(1);
    }
    if (ioctl(f,I2C_SLAVE_FORCE, addr >> 1) < 0) {
	perror("ioctl I2C_SLAVE");
	exit(1);
    }
    if (4 != (rc = write(f,buf,4))) {
	fprintf(stderr,"write: rc=%d, errno=%s\n",rc,strerror(errno));
	exit(1);
    }
    close(f);
    fprintf(stderr,"ok\n");
    exit(0);
}
